﻿/*
 * pettanR peta.common.js
 *   version 0.5.6
 * 
 *   author:
 *     itozyun
 *   licence:
 *     3-clause BSD
 */

var pettanr = ( function(){
	var	IS_LOCAL = document.location.href.indexOf( 'file:') === 0,
		URL_PARAMS = ( function(){
			var search = document.location.search,
				l = search.length;
		    if( 1 < l){
		        var	query = search.substring( 1),
					params = query.split( '&'),
					ret = {}, elm, name, v;
		        while( params.length > 0){
		            elm = params.shift().split( '=');
					name = decodeURIComponent( elm[ 0 ]);
					if( elm.length === 2){
						v = decodeURIComponent( elm[ 1]);
						if( '' + parseFloat( v ) === v ) v = parseFloat( v );
						if( '' + parseInt( v, 10 ) === '0' + v ) v = parseInt( v, 10 );
						if( v === 'true') v = true;
						if( v === 'false') v = false;
						if( v === 'null') v = null;
						if( v === 'undefined') v = undefined;
			            ret[ name] = v;
					} else
					if( elm.length === 1){
						ret[ name] = true;
					}
		        }
		        return ret;
		    }
		    return {};
		})(),
		IS_DEBUG = Type.isBoolean( URL_PARAMS.debug ) ? URL_PARAMS.debug : IS_LOCAL === true;
	return {
		version: '0.5.5',
		URL_PARAMS: URL_PARAMS,
		LOCAL: IS_LOCAL,
		DEBUG: IS_DEBUG,
		LINE_FEED_CODE_TEXTAREA: ( function(){
			var text = document.createElement('textarea');
			text.value = '\n';
			return text.value;
		})(),
		LINE_FEED_CODE_PRE: ( function(){
			var pre = document.createElement('pre');
			pre.appendChild( document.createTextNode('\n'));
			return pre.firstChild.data;
		})()
	}
})();

pettanr.CONST = ( function(){
	var SERVER_SUPPORT    = !( 'has_server_support' in window && has_server_support === false ),
		PETTANR_ROOT_PATH = ( function(){
			if( SERVER_SUPPORT === false ){
				var h1 = document.getElementsByTagName( 'h1' )[ 0 ];
				if( h1 ){
					var a = h1.getElementsByTagName( 'a' )[ 0 ];
					return a ? a.href : '';
				}
				return '';
			};
			var loc = document.location;
			return [ loc.protocol, '\/\/', loc.host, '\/' ].join( '' );
		})(),
		RELATIVE = ( function(){
			if( PETTANR_ROOT_PATH === '' ) return '';
			var ret  = '',
				loc  = document.location,
				path = [ loc.protocol, '\/', loc.host, '\/', loc.pathname.split( '\\' ).join( '\/' ) ].join( '' ),
				l    = path.split( '\/' ).length - PETTANR_ROOT_PATH.split( '\/' ).length;
			for( var i=0; i<l; ++i ){
				ret += '..\/';
			};
			return ret;
		})();
		
	return {
		PETTANR_ROOT_PATH:			PETTANR_ROOT_PATH,
		URL_ORIGINAL_PICTURES_JSON: ( SERVER_SUPPORT === false ? 'json\/' : PETTANR_ROOT_PATH ) + 'original_pictures.json',
		URL_RESOURCE_PICTURES_JSON: ( SERVER_SUPPORT === false ? 'json\/' : PETTANR_ROOT_PATH ) + 'resource_pictures.json',
		URL_COMICS_JSON:			( SERVER_SUPPORT === false ? 'json\/' : PETTANR_ROOT_PATH ) + 'comics.json',
		URL_PANELS_JSON:			( SERVER_SUPPORT === false ? 'json\/' : PETTANR_ROOT_PATH ) + 'panels.json',
		NS_PETTANR_COMIC:			'pettanr-comic',
		RESOURCE_PICTURE_PATH:		( SERVER_SUPPORT === false ? RELATIVE : PETTANR_ROOT_PATH ) + 'resource_pictures\/',
		SYSTEM_PICTURE_PATH:		( SERVER_SUPPORT === false ? RELATIVE : PETTANR_ROOT_PATH ) + 'system_pictures\/',
		CREATE_COMIC_JS:			SERVER_SUPPORT === false ? 'js\/create_new_comic.js' : PETTANR_ROOT_PATH + 'comics\/new.js',
		CREATE_PANEL_JS:			SERVER_SUPPORT === false ? 'js\/create_new_panel.js' : PETTANR_ROOT_PATH + 'panels\/new.js',
		UPLOAD_PICTURE_JS:			SERVER_SUPPORT === false ? 'js\/upload_picture.js' : PETTANR_ROOT_PATH + 'original_pictures\/new.js',
		REGISTER_ARTIST_JS:			SERVER_SUPPORT === false ? 'js\/register_artist.js' : PETTANR_ROOT_PATH + 'artists\/new.js',
		SERVER_SUPPORT:				SERVER_SUPPORT,
		URL_PETA_APPS_CSS:			( SERVER_SUPPORT === false ? 'stylesheets' : '\/assets' ) + '\/peta.apps.css'
	}
})();

/* ----------------------------------------
 * Vector Support
 * 
 *              __________
 *             /          \
 *            /            \
 *            |,startX,Y    |
 * tailX,Y - <              |
 *            |'endX,Y      |
 *            \            /
 * 	           \__________/
 * 
 * SVG
 * -----------------------
 * ie9, other modern browser
 * 
 * XML
 * -----------------------
 * ie5.5-8
 * 
 * 内部の角度計算は radian で統一したい。
 * 当初 vectorEnabled = true で一度書いてみる。
 * 駄目なら、代替のイメージのsrcの用意もここで担当。
 * 閲覧と編集両方で使う。
 * 
 */
pettanr.balloon = ( function() {
	var MIN_BALLOON_WIDTH  = 30,
		MIN_BALLOON_HEIGHT = 30,
		NUM_BALLOON_IMAGE  = 24,
		TAIL_WIDTH         = 6,
		TAIL_HEIGHT        = 10,
		STROKE_WIDTH       = 1.2,
		PADDING_TOP        = TAIL_HEIGHT,
		PADDING_LEFT       = TAIL_HEIGHT,
		IS_VML             = UA.isIE === true && UA.ieVersion < 9,
		ELM_BALLOON_ORIGIN = ( function(){
			var ret;
			try {
				if( IS_VML === true){
					ret = document.createElement( 'DIV');
					var shape = document.createElement( 'v:shape');
					shape.coordorigin = "0,0";
					shape.strokecolor = "black";
					shape.strokeweight = STROKE_WIDTH;
					shape.fillcolor = "white";
					ret.appendChild( shape);
				} else {
					var kSVGNS = 'http://www.w3.org/2000/svg';
					// http://modernizr.com/downloads/modernizr.js
					// Thanks to Erik Dahlstrom
					if( !document.createElementNS || !document.createElementNS(kSVGNS, 'svg').createSVGRect ){
						return null;
					};
					ret = document.createElementNS( kSVGNS, 'svg');
					var path = document.createElementNS( kSVGNS, 'path');
					path.setAttribute( 'fill', "white");
					path.setAttribute( 'stroke', "black");
					path.setAttribute( 'strokeWidth', STROKE_WIDTH);
					ret.appendChild( path );
				};
				return ret;	
			} catch( e){
				return null;
			}
		})(),
		vectorEnabled = ELM_BALLOON_ORIGIN !== null &&
						pettanr.URL_PARAMS.vector !== false &&
						!( IS_VML === true && UA.VML === false );

	var cos        = Math.cos,
		sin        = Math.sin,
		abs        = function(v){ return v >= 0 ? v : -1; },
		pow        = Math.pow,
		round      = Math.round,
		floor      = Math.floor,
		TARGET     = TAIL_WIDTH * TAIL_WIDTH,
		isFinit    = Type.isFinite,
		ACCURACY   = 1, // 有効少数桁	
		cround     = function ( v, r ){
						r = r || ACCURACY;
						return round( v * pow( 10.0, r )) / pow( 10.0, r );
					},
		DEG_TO_RAD = Math.PI / 180;

	var XBROWSER_BALLOON_CLASS = function( w, h, a ){
		var balloonElm = vectorEnabled === true ? ELM_BALLOON_ORIGIN.cloneNode( true ) : document.createElement( 'img' ), // pettanr.imageに変更
			path = balloonElm.getElementsByTagName( 'path' )[ 0 ],
			shape = balloonElm.getElementsByTagName( 'shape' )[ 0 ],
			instance = this,
			l = ',';
		
		function draw( _a ){
			var rx      = w / 2,
				ry      = h / 2,
				tailRad = _a * DEG_TO_RAD,
				tailX   = rx + ( rx + TAIL_HEIGHT ) * sin( tailRad ),
				tailY   = ry - ( ry + TAIL_HEIGHT ) * cos( tailRad ),
				startX, startY, endX, endY;
		/*
		 * tailの太さをTAIL_WIDTHに一致させるため、角度を絞りつつ計算
		 */
			var startRad, endRad,
				_startX, _startY, _endX, _endY,
				tailDeg = 0, d;
			
			for( var i = 45; i > 0.01; i /= 2){
				d = ( tailDeg + i ) /2;
				startRad = ( _a + d ) * DEG_TO_RAD;
				endRad   = ( _a - d ) * DEG_TO_RAD;
				
				_startX  = rx + sin( startRad ) * rx;
				_startY  = ry - cos( startRad ) * ry;
				_endX    = rx + sin( endRad ) * rx;
				_endY    = ry - cos( endRad ) * ry;	//円弧上のY位置＝円中心Y＋sin(角度×PI÷180)×円半径
					
				if( pow( ( _startX - _endX ), 2 ) + pow( ( _startY - _endY ), 2 ) < TARGET ){
					tailDeg += i;
					startX  = _startX;
					startY  = _startY;
					endX    = _endX;
					endY    = _endY;
				};
			};

		/*
		 * 
		 */			
			if( IS_VML === true ){
				var _tailX = tailX *10,
					_tailY = tailY *10,
					__w = w *10,
					__h = h *10;
				
				shape.style.width = w + 'px';
				shape.style.height = h + 'px';
				shape.coordsize = [ __w, __h ].join( l );
				shape.path = [
					' ar ', 0, l, 0, l, __w, l, __h, l,
					round( endX * 10 ), l, round( endY * 10 ), l,
					round( startX * 10 ), l, round( startY * 10 ),
					' l ', round( _tailX ), l, round( _tailY ),
					' x e'
				].join( '');

				balloonElm.style.marginTop =  _tailY < 0 ? floor( ( 60 + _tailY) / 10 ) : 10;
				balloonElm.style.marginLeft = _tailX < 0 ? floor( ( 60 + _tailX) / 10 ) : 10;
			} else {
				balloonElm.setAttribute( 'width', w + PADDING_LEFT *2 );
				balloonElm.setAttribute( 'height', h + PADDING_TOP *2 );
				path.setAttribute( 'd', [
					'M', cround( tailX + PADDING_LEFT ), l, cround( tailY + PADDING_TOP ),
					'L', cround( startX + PADDING_LEFT ), l, cround( startY + PADDING_TOP ),
					'A', rx, l, ry,
					'0 1 1',			// flag
					cround( endX + PADDING_LEFT ), l, cround( endY + PADDING_TOP ),
					'z'
				].join( ' '));
			}
		}
		
		this.elm = balloonElm;
		this.resize = function ( _a, _w, _h ){
			w  = isFinit( _w ) === true ? _w - PADDING_TOP * 2 : w;
			h  = isFinit( _h ) === true ? _h - PADDING_LEFT * 2 : h;
			// ie6 でリサイズが反応しない対策
			if( vectorEnabled === false && UA.isIE === true && UA.ieVersion < 7 ){
				var parent = balloonElm.parentNode;
				parent.removeChild( balloonElm );
				parent.insertBefore( balloonElm, parent.firstChild );
			}
			instance.angle( _a );
		};
		this.angle = function( _a ){
			if( isFinit( _a ) === true ){
				a = _a;
				if( vectorEnabled === false ){
					balloonElm.src = pettanr.balloon.getBalloonUrl( w, h, _a );
				} else {
					draw( _a );
				}
			}
			return a;
		}
		this.type = function( _type ){
			//draw( _a);
		}
		this.destroy = function(){
			delete instance.destroy;
			balloonElm.parentNode && balloonElm.parentNode.removeChild( balloonElm );
			balloonElm = path = shape = instance = null;
		}
		
		instance.resize( a, w, h );
	};
	
	return {
	    createBalloon: function( _w, _h, _a ){
	    	return new XBROWSER_BALLOON_CLASS( _w, _h, _a );
	    },
	    isBalloonInstance: function( _ballon ){
	    	
	    },
	    getBalloonUrl: function( _w, _h, _a ){
			var d = 360 / NUM_BALLOON_IMAGE;
			_a = _a + d / 2;
			return [
				pettanr.CONST.SYSTEM_PICTURE_PATH, '_w',
				_a < 360 - d / 2 ? floor( _a / d ) : 0,
				_w <= 400 || _h <= 400 ? '_b1' : '',
				'.gif' ].join( '' );
	    },
		TYPE_NONE:				0,
		TYPE_SPEACH_BALLOON:	1,
		TYPE_THINKING:			2,
		TYPE_BOM:				3,
		TYPE_BLACK_BOX:			4,
		TYPE_BLUE_BOX:			5
	}
})();

/* ----------------------------------------
 *  pettanr.image
 *  
 *   xBackendな画像反転、画像描画機能。
 *   
 *   画像の反転
 *     - css3
 *     - ActiveX (ie)
 *     - VML (ie)
 *     - canvas ??
 *     - flash(lite)
 *     - silverlight
 *     - pettan server
 *   
 *   png画像の表示(アルファpngをサポートしないie6以下のため)
 *     - ActiveX
 *     - VML
 *     - flash(lite)
 *     - silverlight
 *     
 *     -moz-transform:scale( -1, -1);
 */
pettanr.image = ( function(){
	
	var FetchImageControl = ( function(){
		var TASK_LIST = [];

		/* 
		 * FetchClass original is
		 * 
		 * LICENSE: MIT?
		 *  URL: http://d.hatena.ne.jp/uupaa/20080413/1208067631
		 *  AUTHOR: uupaa.js@gmail.com
		 * 
		 */

		var FetchClass = function( abspath, onLoadCallback, onErrorCallback, delay, timeout ){
			var img,
				size,
				tick = 0,
				timer = null,
				finish = false;
				/*
			if( UA.isIE === false && UA.ieVersion < 8 ){
				var images = document.images,
					i=0, l= images.length;
				for( i=0; i<l; ++i ){
					img = images[ i ];
					if( img.src === abspath && img.complete ){
						finish = true;
						size = Util.getImageSize( img );
						timer = window.setTimeout( asyncCallback, 0 );
						break;
					}
				}
				images = null;
			}*/
			//if( finish === false ){
				img = document.createElement( 'img' ); //var img = new Image(); ではieでimgのsizeが取れない、、、removeChildも失敗し、imgSizeGetterにimgが残る
				img.onabort = img.onerror = onError;
				img.onload = onLoad;
				img.src = abspath;
				finish === false && timeout && detect();
			//}
			
			function onError(){
				if( finish === true ) return;
				finish = true;
				timer = window.setTimeout( asyncCallback, 10 );
			}			
			function onLoad(){
				// if( finish === true ) return; // これがあると firefox3.6 で駄目、、、
				// if( timer ) return; // これがあると safari3.2 で駄目、、、
				finish = true;
				timer !== null && window.clearTimeout( timer );
				if( window.opera && !img.complete ){
					timer = window.setTimeout( asyncCallback, 10 );
					return;
				}
				size = Util.getImageSize( img );
				timer = window.setTimeout( asyncCallback, 10 );
			}
			function detect(){
				if( finish === true ) return;
				if( img.complete ){
					finish = true;
					if( img.width ) return;
					timer = window.setTimeout( asyncCallback, 10 );
					return;
				}
				if( ( tick += delay ) > timeout ){
					finish = true;
					timer = window.setTimeout( asyncCallback, 10 );
					return;
				}
				timer = window.setTimeout( detect, delay );
			}
			
			function asyncCallback(){
				size ? onLoadCallback( abspath, size.width, size.height ) : onErrorCallback( abspath );
				destroy();
			}
			function destroy(){
				finish  = true;
				img.src = img.onload = img.onabort = img.onerror = '';
				img     = void 0;
				size    = onLoadCallback = onErrorCallback = timer = null;
			}
			this.stop = function(){
				timer !== null && window.clearTimeout( timer );
				destroy();			
			}
		}
		
		return {
			load: function( URLorELM, onLoad, onError, delay, opt_timeout ){
				var src, fetch;
				if( Type.isString( URLorELM ) === true ){
					src = URLorELM;
				} else
				if( Type.isHTMLElement( URLorELM ) === true && URLorELM.tagName.toLowerCase() === 'img' ){
					src = URLorELM.src;
				} else {
					return;
				}
				
				fetch = new FetchClass(
					Util.getAbsolutePath( src ),
					onLoad, onError,
					Type.isFinite( delay ) === true ? delay : 250,
					Type.isFinite( opt_timeout ) === true ? opt_timeout : undefined
				);
				// TASK_LIST.push( fetch );
				
				return fetch;
			}
		}
	})();
	
	var REG_PNG           = /\.png?/i,
		IS_CSS3           = 0,
		IS_VML            = 1,
		IS_ACTIVEX        = 2,
		IS_CANVAS         = 3,
		IS_FLASH          = 4,
		IS_SILVERLIGHT    = 5,
		IS_SERVER         = 6,
		IS_ACTIVEX_SERVER = 7,
		BACKEND = ( function(){
			if( pettanr.DEBUG === true && pettanr.URL_PARAMS.rimg ){
				var rimg = pettanr.URL_PARAMS.rimg.toLowerCase();
				if( rimg === 'css3' ) return IS_CSS3;
				if( rimg === 'activex' ) return IS_ACTIVEX;
				if( rimg === 'vml' ) return IS_VML;
			}
			if( UA.isIE === false || UA.ieVersion >= 9 ) return IS_CSS3; // 不十分！
			if( UA.VML === true ) return IS_VML;
			if( UA.ACTIVEX === true ) return IS_ACTIVEX;
			if( pettanr.FLASH === true ) return IS_FLASH;
			if( pettanr.SILVERLIGHT === true ) return IS_SILVERLIGHT;
			return IS_SERVER;
		})(),
		BACKEND_WHEN_PNG = ( function(){
			if( UA.isIE === false || UA.ieVersion > 6 ) return BACKEND;
			if( UA.VML === true ) return IS_VML;
			if( pettanr.FLASH === true ) return IS_FLASH;
			if( pettanr.SILVERLIGHT === true ) return IS_SILVERLIGHT;
			if( UA.ACTIVEX === true ) return IS_ACTIVEX_SERVER;
			return IS_SERVER;
		})(),
		CLASS_NAME         = 'reversible-image-container',
		CLASS_NAME_LOADING = CLASS_NAME + ' loading',
		CLASS_NAME_ERROR   = CLASS_NAME +' error',
		RETRY_DELAY        = 5000,
		NUM_RETRY          = 3,
		ReversibleImageClass,
		ReversibleImageClassWithPingfix;
	
	var css3Image = function( url, w, h, onLoadCallback ){
		var elmWrap    = document.createElement( 'div' ),
			elmImg     = null,
			retryTimer = null,
			fetch      = FetchImageControl.load( url, onLoad, onError, 100, 10000 ),
			instance   = this;
		elmWrap.className = CLASS_NAME_LOADING;

		function onLoad( _url, _actualW, _actualH ){
			if( elmWrap === null ) return;
			elmImg = new Image; // new Image でないと ie6,7 でクラッシュするかも、、、？
			/*
			 * createElement 直後に append しないと、ie(ActiveX)で img が正しく表示されない．
			 */
			elmWrap.appendChild( elmImg );
			elmImg.setAttribute( 'src', url );
			elmWrap.className = CLASS_NAME;
			onLoadCallback && onLoadCallback( _url, _actualW, _actualH );
			onLoadCallback = fetch = null;
			instance.resize( w, h );
		}
		function onError( _url ){
			if( elmWrap === null ) return;
			elmWrap.className = CLASS_NAME_ERROR;
			retryTimer = window.setTimeout( retry, RETRY_DELAY );
			fetch = null;
		}
		function retry(){
			elmWrap.className = CLASS_NAME_LOADING;
			fetch = FetchImageControl.load( url, onLoad, onError, 100, 10000 );
		}

		this.elm = elmWrap;
		this.resize = function( _w, _h ){
			w = _w !== undefined ? _w : w;
			h = _h !== undefined ? _h : h;
			if( elmImg === null ) return;
			elmImg.className = w < 0 || h < 0 ? ( 'img-flip-' + ( w < 0 && h < 0 ? 'vh' : ( w < 0 ? 'h' : 'v'))) : '';
		}
		this.destroy = function(){
			delete instance.destroy;
			
			elmImg !== null && elmWrap.removeChild( elmImg );
			retryTimer !== null && window.clearTimeout( retryTimer );
			fetch !== null && fetch.stop();
			elmWrap = elmImg = onLoadCallback = retryTimer = fetch = instance = null;
		}
	}
		
	var activexImage = css3Image;
	
	var vmlImage = function( url, w, h, onLoadCallback ){
		var elmWrap = document.createElement( 'div' ),
			vmlImg = null,
			retryTimer = null,
			fetch = FetchImageControl.load( url, onLoad, onError, 100, 10000 ),
			instance = this;
		elmWrap.className = CLASS_NAME_LOADING;
		function onLoad( _url, _actualW, _actualH ){
			if( elmWrap === null ) return;
			elmWrap.className = CLASS_NAME;
			vmlImg = document.createElement( 'v:image' );
			vmlImg.src = url;
			onLoadCallback && onLoadCallback( _url, _actualW, _actualH );
			onLoadCallback = fetch = null;
			instance.resize( w, h );
		}
		function onError( _url ){
			if( elmWrap === null ) return;
			elmWrap.className = CLASS_NAME_ERROR;
			retryTimer = window.setTimeout( retry, RETRY_DELAY );
			fetch = null;
		}
		function retry(){
			elmWrap.className = CLASS_NAME_LOADING;
			fetch = FetchImageControl.load( url, onLoad, onError, 100, 10000 );
		}
		
		this.elm = elmWrap;
		this.resize = function( _w, _h ){
			w = _w !== undefined ? _w : w;
			h = _h !== undefined ? _h : h;
			if( vmlImg === null ) return;
			vmlImg.style.width  = ( w < 0 ? -w : w ) + 'px';
			vmlImg.style.height = ( h < 0 ? -h : h ) + 'px';
			//if( flipH !== _flipH || flipV !== _flipV){
				vmlImg.parentNode === elmWrap && elmWrap.removeChild( vmlImg );
			//}
				vmlImg.className = w < 0 || h < 0 ? ( 'img-flip-' + ( w < 0 && h < 0 ? 'vh' : ( w < 0 ? 'h' : 'v'))) : '';
				elmWrap.appendChild( vmlImg );
		}
		this.destroy = function(){
			instance.destroy;
			
			vmlImg !== null && elmWrap.removeChild( vmlImg );
			retryTimer !== null && window.clearTimeout( retryTimer );
			fetch !== null && fetch.stop();
			elmWrap = vmlImg = onLoadCallback = retryTimer = fetch = instance = null;
		}
	}
	
	var serverImage = css3Image; // function( url, w, h, onLoadCallback ){}
	
	if( BACKEND === IS_CSS3 )    ReversibleImageClass = css3Image;
	if( BACKEND === IS_VML )     ReversibleImageClass = vmlImage;
	if( BACKEND === IS_ACTIVEX ) ReversibleImageClass = activexImage;
	if( BACKEND === IS_SERVER )  ReversibleImageClass = activexImage;
	
	css3Image = vmlImage = activexImage = activexImage = null;
	
	return {
		createReversibleImage: function( url, w, h, onLoadCallback){
			return new ReversibleImageClass( url, w, h, onLoadCallback );
		}
	}
})();

/*
 * bind : 製本
 */
pettanr.bind = ( function(){
	var BIND_WORKER_ARRAY = [],
		NAMESPACE_CLASSNAME = pettanr.CONST.NS_PETTANR_COMIC + '-',
		RESOURCE_PICTURE_PATH = pettanr.CONST.RESOURCE_PICTURE_PATH,
		ELM_DETECT_WIDTH = ( function(){
			var ret = document.createElement( 'div');
			ret.style.cssText = 'width: auto;height: 0;padding: 0;margin: 0;display: block;visibility: hidden;float: none;position: static;';
			return ret;
		})(),
		ELM_TITLE_ORIGN = ( function(){
			
		})();

	/*
	 * original
	 *   http://d.hatena.ne.jp/uupaa/20090720/1248097177
	 */
	var ResizeAgentClass = function( onResizeFunction, opt_elmCheck){
		var	_globalLock = 0,
			_size = { w: 0, h: 0 };
			_ie = !!document.all,
			_quirks = (document.compatMode || "") !== "CSS1Compat",
			_ieroot = _quirks ? "body" : "documentElement";
			_root = opt_elmCheck ? opt_elmCheck : ( _ie ? document[_ieroot] : window);

		function getInnerSize(){
			return {
				w: _root.innerWidth  || _root.clientWidth,
				h: _root.innerHeight || _root.clientHeight
			};
		};

		function loop(){
			if (!_globalLock++) {
				var size = getInnerSize();
				if (_size.w !== size.w || _size.h !== size.h) { // resized
					_size = size; // update
					onResizeFunction( _size );
				};
				setTimeout( unlock, 0); // delay unlock
			};
			setTimeout(loop, 500);
		};
		function unlock(){
			_globalLock = 0;
		};
		loop();
	};
	
	
	var ElementBuilderClass = function( elmTarget, noClassnameMode ){
		var RIMG_ARRAY     = [],
			BALLOON_ARRAY  = [];
		
		function buildComicElement(){
			
		};
		
		function buildPanelElement( json, zoom ){
			var _elmPanel = document.createElement( 'div' ),
				_style = {
						'border-width':		typeof json.border === 'number' ? json.border + 'px' : 0,
						width: 				json.width + 'px',
						height:				json.height + 'px'
				},
				_cssText = [],
				_comicElements = json.panel_elements || [],
				_comicElement, _elmImg, _rImg, _rPic,
				_balloon, _elmBalloonWrap, _elmText, _text, _speechesAttributes, _key;
			elmTarget.appendChild( _elmPanel );
			
			if( noClassnameMode === true ){
				
			} else {
				_elmPanel.className = NAMESPACE_CLASSNAME + 'panel';
			}
			for( var _key in _style ){
				_cssText.push( _key + ':' + _style[ _key ] );
			}
			_elmPanel.style.cssText = _cssText.join( ';' );
			
			for( var i=0, l=_comicElements.length; i<l; ++i ){
				_comicElement = _comicElements[ i ];
				_rPic = _comicElement.resource_picture;
				if( _rPic ){
					_rImg = pettanr.image.createReversibleImage(
							[ RESOURCE_PICTURE_PATH, _rPic.id, '.', _rPic.ext ].join( ''),
							_comicElement.width, _comicElement.height
						);
					_elmImg = _rImg.elm;
					_elmPanel.appendChild( _elmImg );
					_elmImg.className = NAMESPACE_CLASSNAME + 'image';
					_elmImg.style.cssText = [
						'left:',   _comicElement.x, 'px;',
						'top:',    _comicElement.y, 'px;',
						'z-index:',_comicElement.z, ';'
					].join( '');					
					if( _elmImg.tagName === 'img' ){
						_elmImg.width        = Math.abs( _comicElement.width );
						_elmImg.height       = Math.abs( _comicElement.height );
					} else {
						_elmImg.style.width  = Math.abs( _comicElement.width ) + 'px';
						_elmImg.style.height = Math.abs( _comicElement.height ) + 'px';
					};
					
					RIMG_ARRAY.push( _rImg );
				} else {
					_elmBalloonWrap = document.createElement( 'div' );
					_elmPanel.appendChild( _elmBalloonWrap );
					_elmBalloonWrap.className = NAMESPACE_CLASSNAME + 'balloon';
					_elmBalloonWrap.style.cssText = [
						'width:',   _comicElement.width, 'px;',
						'height:',  _comicElement.height, 'px;',
						'left:',    _comicElement.x, 'px;',
						'top:',     _comicElement.y, 'px;',
						'z-index:', _comicElement.z, ';'
					].join( '');

					_balloon = pettanr.balloon.createBalloon( _comicElement.width, _comicElement.height, _comicElement.tail );
					_elmBalloonWrap.appendChild( _balloon.elm );
					
					_elmText = document.createElement( 'p' );
					_elmBalloonWrap.appendChild( _elmText );
					
					_elmText.appendChild( document.createElement( 'span' ) );
					
					_text = '';
					_speechesAttributes = _comicElement.speeches_attributes;
					if( _speechesAttributes ){
						for( _key in _speechesAttributes ){
							_text += _speechesAttributes[ _key ] && _speechesAttributes[ _key ].content ? _speechesAttributes[ _key ].content : '';
						};
					};
					_elmText.firstChild.appendChild( document.createTextNode( _text ));
					BALLOON_ARRAY.push( _balloon );
				};
			};
		};
		
		function clean(){
			// clean elmTarget
			while( RIMG_ARRAY.length > 0 ){
				RIMG_ARRAY.shift().destroy();
			};
			while( BALLOON_ARRAY.length > 0 ){
				BALLOON_ARRAY.shift().destroy();
			};
			Util.removeAllChildren( elmTarget );		
		};
		
		this.build = function( json, zoom ){
			clean();
			
			// json is Comic ? Panel ?
			var panels = json.stories;
			if( Type.isArray( panels ) === true ){
				// comic
				for( var i=0, l=panels.length; i<l; ++i ){
					buildPanelElement( panels[ i ], zoom );
				};
			} else
			if( json.panel_elements ){
				// panel
				buildPanelElement( json, zoom );
			} else {
				// invalid json
			};
		};
		this.zoom = function(){
			
		};
		this.destroy = function(){
			clean();
		};
	};
	
	var BindWorkerClass = function( elmTarget, json, zoomSelfEnabled, noClassnameMode ){
		var builder    = new ElementBuilderClass( elmTarget, noClassnameMode );
		var elmDetectW = ELM_DETECT_WIDTH.cloneNode( false );
		var resizer    = null;
		
		if( zoomSelfEnabled === true ){
			elmTarget.parentNode.insertBefore( elmDetectW, elmTarget );
			resizer = new ResizeAgentClass( onResize, elmDetectW );
		};
		function onResize(){
			
		};
		json && typeof json === 'object' && builder.build( json );
		
		this.init = function(){
				
		};
		this.zoom = function(){
			builder.zoom();
		};
		this.json = function( _json ){
			json = _json;
			builder.build( _json );
		};
		this.targetElement = function(){
				
		};
		this.layout = function(){
				
		};
		this.destroy = function(){
			builder.destroy();
			elmTarget = json = builder = null;
		};
	};
	
	return {
		createBindWorker: function( elmTarget, opt_COMICJSONorPANELJSON, opt_zoomSelfEnabled, opt_noClassnameMode ){
			var ret = new BindWorkerClass( elmTarget, opt_COMICJSONorPANELJSON, !!opt_zoomSelfEnabled, !!opt_noClassnameMode);
			BIND_WORKER_ARRAY.push( ret );
			return ret;
		},
		isBindWorkerInstance: function( _bindWorker ){
			return _bindWorker instanceof BindWorkerClass;
		}
	}
})();

var VisualEffect = ( function(){
	
	var ANIMATION_TICKET_ARRAY = [],
		fpms = 50,
		TIMER = null,
		FILTER = 'filter',
		OPACITY = 'opacity',
		REG_ALPHA = /alpha\([^)]*\)/i,
		CORON = ':',
		EMPTY = '',
		SEMICORON = ';';
	
	function startAnimation( _elm, _cssObject, _onComplete, _onEnterFrame, _numFrames){
		var _ticket;
		for( var i=0, l=ANIMATION_TICKET_ARRAY.length; i<l; ++i){
			_ticket = ANIMATION_TICKET_ARRAY[ i];
			if( _ticket.elm === _elm) {
				_ticket.destroy();
				break;
			}
		}
		//  coputedStyle と _cssObject を比較して , 一致及び非数は削除しつつ コピー
		//  filter opacity の追加 REG_ALPHA.test( _value ) ? _value.replace( REG_ALPHA, opacity ) : _value + " " + opacity
		/*
		 * cssObject をまわす
		 * 非数は削除
		 * cssText と一致も削除
		 * coputedStyle と一致も削除
		 * updateTraget ととして記録
		 * 初期値を cssObject としてセット
		 * cssTest にセット zoom もセット
		 */
		
		//
		/*
			var style = elem.style,
				currentStyle = elem.currentStyle,
				opacity = jQuery.isNumeric( value ) ? "alpha(opacity=" + value * 100 + ")" : "",
				filter = currentStyle && currentStyle.filter || style.filter || "";

			// IE has trouble with opacity if it does not have layout
			// Force it by setting the zoom level
			style.zoom = 1;
		 */
		
		var _currentParameters = [],
			_offsetParameters = [],
			_endParameters = [],
			_targetAttributes = [];
		
		ANIMATION_TICKET_ARRAY.push( new AnimationTaskClass(
			_elm,
			_currentParameters, _offsetParameters, _endParameters, _targetAttributes,
			typeof _onComplete === 'function' ? _onComplete : null,
			typeof _onEnterFrame === 'function' ? _onEnterFrame : null,
			_numFrames
		));
		
		if( TIMER === null){
			TIMER = window.setInterval( onEnterFrame, fpms);
		}
	}
	function onEnterFrame(){
		var _ticket,
			i = 0;
		while( i<ANIMATION_TICKET_ARRAY.length){
			_ticket = ANIMATION_TICKET_ARRAY[ i];
			if( _ticket.onEnterFrame() === true){
				_ticket.destroy();
				ANIMATION_TICKET_ARRAY.splice( i, 1);
			} else {
				++i;
			}
		}
		if( ANIMATION_TICKET_ARRAY.length === 0){
			window.clearInterval( TIMER);
			TIMER = null;
		}
	}
	function updateCss( _elm, _updateParameters, _targetAttributes, _numAttributes){
		if( _numAttributes > 1){
			var _cssTexts = _elm.style.cssText.split( ';'), _css,
				_separate,
				_cssObject = {}, _target, _value, _number, _px,
				j;
			for(var i=0, l=_cssTexts.length; i<l; ++i){
				_css = _cssTexts[ i];
				_separate = _css.indexOf( ':');
				if( _separate >= 3){
					_target = _css.substr( 0, _separate +1);
					_value = _css.substr( _separate +1);
					/*
					 * ie filter
					 */
					if( _target === FILTER){
						for( j=0; j<_numAttributes; ++j){
							if( _targetAttributes[ j] === OPACITY){
								_cssTexts[ i] = [
										_target, ':',
										_value.replace( REG_ALPHA, "alpha(opacity=" + _updateParameters[ j] * 100 + ")")
									].join( '');
								break;
							}
						}
					/*
					 * other
					 */
					} else {
						_number = '' + parseFloat( _value);
						_px = _value.indexOf( _number);
						_px = _px > 0 ? _value.substr( _px + _number.length) : '';
						for( j=0; j<_numAttributes; ++j){
							if( _targetAttributes[ j] === _target){
								_cssTexts[ i] = [ _target, ':', _updateParameters[ j], _px].join( '');
								break;
							}
						}						
					}
				}
			}
			_elm.style.cssText = _cssTexts.join( ';');
			return;	
		}
		/*
		 * 一度に update する Attributes が少ない場合、cssText は使用しない.
		 */
	}
	
	var AnimationTaskClass = function( ELM, currentParameters, offsetParameters, endParameters, targetAttributes, onComplete, onEnterFrame, numFrames){
		var l = targetAttributes.length;
		return {
			elm:	ELM,
			onEnterFrame: function(){
				var _updateCss = {}, i;
				if( numFrames === 1){
					for( i=0; i<l; ++i){
						_updateCss[ targetAttributes[ i]] = endParameters[ i];
						++i;
					}
					updateCss( ELM, currentParameters, targetAttributes, l);
					onComplete !== null && onComplete();
				} else {
					for( i=0; i<l; ++i){
						_updateCss[ targetAttributes[ i]] = currentParameters[ i] = Math.floor( currentParameters[ i] + offsetParameters[ i]);
						++i;
					}
					updateCss( ELM, currentParameters, targetAttributes, l);
					onEnterFrame !== null && onEnterFrame( _updateCss);
				}
				--numFrames;
				return numFrames === 0;
			},
			destroy: function(){
				ELM = onComplete = onEnterFrame = null;
			}
		}
	}
	
	var VisualEffectClass = function( ELM){
		var isHtmlElement;
		
		function registerAnime( _cssObject, _onComplete, _onEnterFrame, _time){
			var _numFrames = Math.floor( _time / fpms);
			startAnimation( ELM, _cssObject, _onComplete, _onEnterFrame, _numFrames);
		}
		function startFadeIn(){
			
		}
		function startFadeOut(){
			
		}
		function update( _x, _y, _w, _h){
			var _cssText = ELM.style.cssText;
			
		}
		
		this.anime = registerAnime;
		this.fadeIn = startFadeIn;
		this.fadeOut = startFadeOut;
		this.update = update;
	}
	
	return {
		createVisualEffect: function( _elm){
			return new VisualEffectClass( _elm);
		},
		isInstanceOfVisualEffect: function( _instance){
			return _instance instanceof VisualEffectClass;
		}
	}
})();



/*
 *  Google Analytics
 */

if( pettanr.LOCAL === false ){
	var _gaq = _gaq || [];
	_gaq.push(['_setAccount', 'UA-28023955-1']);
	_gaq.push(['_trackPageview']);
	
	(function() {
		var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
		ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
		var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
	})();	
}