class AuthorsController < ApplicationController
  before_filter :authenticate_user!, :only => [:index, :show, :edit, :update]
  before_filter :authenticate_admin!, :only => [:list, :browse]

  def index
    @page = Author.page params[:page]
    @page_size = Author.page_size params[:page_size]
    @authors = Author.list(@page, @page_size)

    respond_to do |format|
      format.html # index.html.erb
      format.json { render :json => @authors.to_json(Author.list_json_opt) }
    end
  end

  def show
    @au = Author.show(params[:id], @author)

    respond_to do |format|
      format.html
      format.json { render :json => @au.to_json(Author.show_json_opt) }
    end
  end

  def count
    @au = {:count => Author.visible_count}
    respond_to do |format|
      format.json { render json: @au.to_json }
    end
  end
  
  def list
    @authors = Author.all

    respond_to do |format|
      format.html { render layout: 'system' }
    end
  end

  def browse
    @author = Author.find(params[:id])

    respond_to do |format|
      format.html { render layout: 'system' }
    end
  end
  
  def edit
    @au = Author.edit(params[:id], @author)
  end

  def update
    @au = Author.edit(params[:id], @author)
    @au.attributes = params[:author]
    @au.overwrite

    respond_to do |format|
      if @au.save
        format.html { redirect_to @au, notice: 'Author was successfully updated.' }
        format.json { head :ok }
      else
        format.html { render action: "edit" }
        format.json { render json: @au.errors, status: :unprocessable_entity }
      end
    end
  end
end
