class PanelColor < ActiveRecord::Base
  belongs_to :panel
  
  validates :panel_id, :numericality => {:allow_blank => true}
  validates :z, :presence => true, :numericality => {:greater_than => 0}
  validates :code, :presence => true, :numericality => {:greater_than_or_equal_to => 0, :less_than => 0x1000000}
  
  def supply_default
  end
  
  def overwrite
  end
  
  def self.default_page_size
    25
  end
  
  def self.max_page_size
    100
  end
  
  def self.page prm = nil
    page = prm.to_i
    page = 1 if page < 1
    page
  end
  
  def self.page_size prm = self.default_page_size
    page_size = prm.to_i
    page_size = self.max_page_size if page_size > self.max_page_size
    page_size = self.default_page_size if page_size < 1
    page_size
  end
  
  def self.list page = 1, page_size = self.default_page_size
    opt = {}
    opt.merge!(PanelColor.list_opt)
    opt.merge!({:limit => page_size, :offset => (page -1) * page_size}) if page_size > 0
    opt.merge!({:conditions => 'panels.publish > 0', :order => 'panel_colors.updated_at desc'})
    PanelColor.find(:all, opt)
  end
  
  def self.list_opt
    {:include => {:panel => {:author => {}} }}
  end
  
  def self.list_json_opt
    {:include => {:panel => {:author => {}} }}
  end
  
  def self.mylist au, page = 1, page_size = Author.default_panel_color_page_size
    opt = {}
    opt.merge!(PanelColor.list_opt)
    opt.merge!({:limit => page_size, :offset => (page -1) * page_size}) if page_size > 0
    opt.merge!({:conditions => ['panels.author_id = ?', au.id], :order => 'panel_colors.updated_at desc'})
    PanelColor.find(:all, opt)
  end
  
end
